void show_humidity () {
  // call the sensor and take returned value and display as two BCD nibbles
  //   display is in 4 left most leds [H8, H4, H2, H1] for most sig digit M and 
  //     4 right  most leds [M8, M4, M2, M1] for least sig digit L
  //   display will be in Blue 

  Leds_off ();                             // clear the previous display
  
  float humf = dht.readHumidity ();   // read the humidity
  
  if (!isnan(humf)) {     //good read as it is a number, a sensor fault fails this test

    int hum = round(humf);              // make it an int to just get xy% not xy.zz%
    itoa (hum, hum_str, 10);               //for display on Oled

    int rhbcd = hum % 10;    // extract the single digits, ie the least significant digit L
    switch (rhbcd) {
      case 9:
        leds.setPixelColor (M8, Blue);
        leds.setPixelColor (M1, Blue);
        break;
      case 8:
        leds.setPixelColor (M8, Blue);
        break;
      case 7:
        leds.setPixelColor (M4, Blue);
        leds.setPixelColor (M2, Blue);
        leds.setPixelColor (M1, Blue);
        break;
      case 6:
        leds.setPixelColor (M4, Blue);
        leds.setPixelColor (M2, Blue);
        break;
      case 5:
        leds.setPixelColor (M4, Blue);
        leds.setPixelColor (M1, Blue);
        break;
      case 4:
        leds.setPixelColor (M4, Blue);
        break;
      case 3:
        leds.setPixelColor (M2, Blue);
        leds.setPixelColor (M1, Blue);
        break;
      case 2:
        leds.setPixelColor (M2, Blue);
        break;
      case 1:
        leds.setPixelColor (M1, Blue);
        break;
      // default:  not needed as all leds would be off
    }

    int lhbcd = hum /10;     // int arithmetic rounds, ie extract the most significant digit M
    switch (lhbcd) {
      case 9:
        leds.setPixelColor (H8, Blue);
        leds.setPixelColor (H1, Blue);
        break;
      case 8:
        leds.setPixelColor (H8, Blue);
        break;
      case 7:
        leds.setPixelColor (H4, Blue);
        leds.setPixelColor (H2, Blue);
        leds.setPixelColor (H1, Blue);
        break;
      case 6:
        leds.setPixelColor (H4, Blue);
        leds.setPixelColor (H2, Blue);
        break;
      case 5:
        leds.setPixelColor (H4, Blue);
        leds.setPixelColor (H1, Blue);
        break;
      case 4:
        leds.setPixelColor (H4, Blue);
        break;
      case 3:
        leds.setPixelColor (H2, Blue);
        leds.setPixelColor (H1, Blue);
        break;
      case 2:
        leds.setPixelColor (H2, Blue);
        break;
      case 1:
        leds.setPixelColor (H1, Blue);
        break;
      // default:  not needed as all leds would be off
      }
    }
  
  else {
    
    // bad read from DHT module
    strcpy(hum_str, "xx");
                 
    //bad read from sensor as not a number, so show all blue
    leds.setPixelColor (H8, Blue);
    leds.setPixelColor (H4, Blue);
    leds.setPixelColor (H2, Blue);
    leds.setPixelColor (H1, Blue);

    leds.setPixelColor (M32, Blue);
    leds.setPixelColor (M16, Blue);
    leds.setPixelColor (M8, Blue);
    leds.setPixelColor (M4, Blue);
    leds.setPixelColor (M2, Blue);
    leds.setPixelColor (M1, Blue);
  }

  leds.show();   // display the humidity as M L where each digit is a BCD nibble
}

