void show_temp () {
  // call the sensor and take the returned value and display as Binary 
  //   display in minutes field so limits {0 .. 63°C]
  //   display in Red 

  Leds_off ();                             // clear the previous display
  
  float tempf = dht.readTemperature ();    // read temperature from sensor, default is Celcius
  
  if (!isnan(tempf)) {    //good read as it is a number, a sensor fault fails this test
                          //   and to indicate this we dispaly all leds red 

    int temp = round(tempf);                 // make it an int to just get xy °C not xy.zz °C
    itoa (temp, temp_str, 10);               //for display on Oled                      

    if (temp >= 32) {
      leds.setPixelColor (M32, Red);
      temp -= 32;
    }
    if (temp >= 16) {
      leds.setPixelColor (M16, Red);
      temp -= 16;
    }
    if (temp >= 8) {
      leds.setPixelColor (M8, Red);
      temp -= 8;
    }
    if (temp >= 4) {
      leds.setPixelColor (M4, Red);
      temp -= 4;
    }
    if (temp >= 2) {
      leds.setPixelColor (M2, Red);
      temp -= 2;
    }
    if (temp >= 1) {
      leds.setPixelColor (M1, Red);
    }
  }
  
  else {
    // bad read from DHT module
    strcpy(temp_str, "xx");
               
    //bad read from sensor as not a number, so show all red
    leds.setPixelColor (M32, Red);
    leds.setPixelColor (M16, Red);
    leds.setPixelColor (M8, Red);
    leds.setPixelColor (M4, Red);
    leds.setPixelColor (M2, Red);
    leds.setPixelColor (M1, Red);

    leds.setPixelColor (H8, Red);
    leds.setPixelColor (H4, Red);
    leds.setPixelColor (H2, Red);
    leds.setPixelColor (H1, Red);
  }

  leds.show();
}
